import 'dart:convert';
import 'dart:io';
import 'package:benchmark_harness/benchmark_harness.dart';

class RegExpBenchmark1 extends BenchmarkBase {
  RegExp _data;

  RegExpBenchmark1() : super("RegExp1");

  static void main() {
    new RegExpBenchmark1().report();
  }


  void setup() {
      _data = new RegExp(
          "^[\u{2000}-\u{206F}\u{2E00}-\u{2E7F}\\\\'!\"#\\\$%&\\(\\)\\*\\+,\\-\\.\\/:;<=>\\?@\\[\\]\\^_`\\{\\|\\}~]");
  }

  void run() {
    _data.hasMatch('!');
    _data.hasMatch(' ');
    _data.hasMatch('\n');
    _data.hasMatch('[');
    _data.hasMatch('z');
    _data.hasMatch('—');
  }
}

class RegExpBenchmark2 extends BenchmarkBase {
  RegExp _data;

  RegExpBenchmark2() : super("RegExp2");

  static void main() {
    new RegExpBenchmark2().report();
  }


  void setup() {
      _data = new RegExp(
          "[\u{2000}-\u{206F}\u{2E00}-\u{2E7F}\\\\'!\"#\\\$%&\\(\\)\\*\\+,\\-\\.\\/:;<=>\\?@\\[\\]\\^_`\\{\\|\\}~]");
  }

  void run() {
    _data.hasMatch('!');
    _data.hasMatch(' ');
    _data.hasMatch('\n');
    _data.hasMatch('[');
    _data.hasMatch('z');
    _data.hasMatch('—');
  }
}

class SetBenchmark extends BenchmarkBase {
  Set<String> _data;

  SetBenchmark() : super("Set");

  static void main() {
    new SetBenchmark().report();
  }


  void setup() {
      _data = new Set();
      var r = new RegExp(r'^\s');
      for (var i = 0; i < 30000; i++) {
        if (r.hasMatch(new String.fromCharCode(i))) {
          _data.add(new String.fromCharCode(i));
        }
      }
  }

  void run() {
    _data.contains('!');
    _data.contains(' ');
    _data.contains('\n');
    _data.contains('[');
    _data.contains('z');
    _data.contains('—');
  }
}

class IfBenchmark extends BenchmarkBase {
  Map<String, bool> _data;

  MapBenchmark() : super("Map");

  static void main() {
    new MapBenchmark().report();
  }


  void setup() {
      _data = new Map.fromIterable(data, key: (key) => key, value: (_) => true);
  }

  void run() {
    _data['aaa'] != null;
    _data['https'] != null;
    _data['ymsgr'] != null;
  }
}

main() {
  RegExpBenchmark1.main();
  RegExpBenchmark2.main();
  //SetBenchmark.main();
  //MapBenchmark.main();
}
